/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 1
Date    : 23.12.2014
Author  : MyComp
Company : MyComp
Comments: 
 -   
     
    (30.0),   
     (3.00).
   0,1 .

Chip type               : ATmega8L
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

 #include <mega8.h>
 #include <delay.h>  // 
 #include <math.h>   // 
           
 // Declare your global variables here
 unsigned char chislo [8];  //     
 bit flag_indikaciya = 1;  //    
 unsigned char tochka_volt = 10;  //      ,    10,    
 unsigned char tochka_amper = 10; //      ,    10,    
  
 flash unsigned char kooficient_millivolt = 30;  //      
 flash float kooficient_milliamper = 3.125;  //      
 
 //     0  9    
 flash unsigned char simvol [16] = {0b11000000,/*0*/  0b11111001,/*1*/  0b10100100,/*2*/  0b10110000,/*3*/
                                    0b10011001,/*4*/  0b10010010,/*5*/  0b10000010,/*6*/  0b11111000,/*7*/ 
                                    0b10000000,/*8*/  0b10010000,/*9*/  0b11100011,/*u*/  0b11101111,/*i*/
                                    0b11000001,/*U*/  0b11001111,/*I*/  0b10001100,/*P*/  0b11111111 /* */};                                
                               
                            
                            
 #define FIRST_ADC_INPUT 0
 #define LAST_ADC_INPUT 1
 unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];  //       0(U)  1(I)
 // Voltage Reference: Int., cap. on AREF
 #define ADC_VREF_TYPE ((1<<REFS1) | (1<<REFS0) | (0<<ADLAR))
                                   
 
 
 // Timer2 output compare interrupt service routine
 // / 2  480     ( 8 )
 interrupt [TIM2_COMP] void timer2_comp_isr(void)
 {
 static unsigned char razryat = 0;  //     

 PORTD = simvol [15];  //    
 switch (razryat)   //   
   {
   case 0: PORTB = 0b00000001; break;  //   0  
   case 1: PORTB = 0b00000010; break;  //   1  
   case 2: PORTB = 0b00000100; break;  //   2  
   case 3: PORTB = 0b00001000; break;  //   3  
   case 4: PORTB = 0b00010000; break;  //   4  
   case 5: PORTB = 0b00100000; break;  //   5  
   case 6: PORTB = 0b01000000; break;  //   6  
   case 7: PORTB = 0b10000000; break;  //   7  
   //       
   default: razryat = 0;       break;  //  
   }
   
 PORTD = simvol[ chislo[razryat] ];      //        
 
 //          , 
 if ((tochka_volt == razryat) ||(tochka_amper == razryat))
   {
   PORTD.7 = 0;  //    
   }
        
 razryat++;  //   1
 if (razryat > 7)  //      ,     
   {
   razryat = 0;  //  
   flag_indikaciya = 1;  //    
   }      

 }

 
 
 // ADC interrupt service routine
 // with auto input scanning
 //         
 interrupt [ADC_INT] void adc_isr(void)
 {
 static unsigned char input_index=0;
 // Read the AD conversion result
 adc_data[input_index]=ADCW;
 // Select next ADC input
 if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
   input_index=0;
 ADMUX=(FIRST_ADC_INPUT | ADC_VREF_TYPE)+input_index;
 // Delay needed for the stabilization of the ADC input voltage
 delay_us(10);
 // Start the AD conversion
 ADCSRA|=(1<<ADSC);
 }
 
 
 
 void main(void)  //  
 {
 // Declare your local variables here
 unsigned int millivolt;  //   
 unsigned int milliamper;  //        
 unsigned int temp_raschyot;  //  
 float temp_milliamper;  //    

 // Input/Output Ports initialization
 // Port B initialization
 // Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
 DDRB=(1<<DDB7) | (1<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
 // State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
 PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

 // Port C initialization
 // Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
 DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
 // State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
 PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

 // Port D initialization
 // Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
 DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (1<<DDD3) | (1<<DDD2) | (1<<DDD1) | (1<<DDD0);
 // State: Bit7=1 Bit6=1 Bit5=1 Bit4=1 Bit3=1 Bit2=1 Bit1=1 Bit0=1 
 PORTD=(1<<PORTD7) | (1<<PORTD6) | (1<<PORTD5) | (1<<PORTD4) | (1<<PORTD3) | (1<<PORTD2) | (1<<PORTD1) | (1<<PORTD0);

 // Timer/Counter 0 initialization
 // Clock source: System Clock
 // Clock value: Timer 0 Stopped
 TCCR0=(0<<CS02) | (0<<CS01) | (0<<CS00);
 TCNT0=0x00;

 // Timer/Counter 1 initialization
 // Clock source: System Clock
 // Clock value: Timer1 Stopped
 // Mode: Normal top=0xFFFF
 // OC1A output: Disconnected
 // OC1B output: Disconnected
 // Noise Canceler: Off
 // Input Capture on Falling Edge
 // Timer1 Overflow Interrupt: Off
 // Input Capture Interrupt: Off
 // Compare A Match Interrupt: Off
 // Compare B Match Interrupt: Off
 TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
 TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
 TCNT1H=0x00;
 TCNT1L=0x00;
 ICR1H=0x00;
 ICR1L=0x00;
 OCR1AH=0x00;
 OCR1AL=0x00;
 OCR1BH=0x00;
 OCR1BL=0x00;

 // Timer/Counter 2 initialization
 // Clock source: System Clock
 // Clock value: 3,906 kHz
 // Mode: CTC top=OCR2A
 // OC2 output: Disconnected
 // Timer Period: 2,304 ms
 ASSR=0<<AS2;
 TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (1<<CTC2) | (1<<CS22) | (1<<CS21) | (1<<CS20);
 TCNT2=0x00;
 OCR2=0x08;  //480   

 // Timer(s)/Counter(s) Interrupt(s) initialization
 TIMSK=(1<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<TOIE0);

 // External Interrupt(s) initialization
 // INT0: Off
 // INT1: Off
 MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);

 // USART initialization
 // USART disabled
 UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (0<<RXEN) | (0<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);

 // Analog Comparator initialization
 // Analog Comparator: Off
 // The Analog Comparator's positive input is
 // connected to the AIN0 pin
 // The Analog Comparator's negative input is
 // connected to the AIN1 pin
 ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);

 // ADC initialization
 // ADC Clock frequency: 125,000 kHz
 // ADC Voltage Reference: Int., cap. on AREF
 ADMUX=FIRST_ADC_INPUT | ADC_VREF_TYPE;
 ADCSRA=(1<<ADEN) | (1<<ADSC) | (0<<ADFR) | (0<<ADIF) | (1<<ADIE) | (1<<ADPS2) | (0<<ADPS1) | (1<<ADPS0);
 SFIOR=(0<<ACME);

 // SPI initialization
 // SPI disabled
 SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);

 // TWI initialization
 // TWI disabled
 TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);

 // Global enable interrupts
 #asm("sei")  // 

 while (1)  //  
   {
   millivolt = adc_data[0] * kooficient_millivolt;  //    
   temp_milliamper = adc_data[1] * kooficient_milliamper;  //     
   milliamper = floor(temp_milliamper);  //        

   if (flag_indikaciya == 1)  //     
     {
     tochka_volt = 10;  //    

     if (millivolt > 30600)  //   30600, 
       {
       chislo[3] = 12;   // /*U*/
       chislo[2] = 15;   // /* */
       chislo[1] = 10;   // /*u*/
       chislo[0] = 14;   // /*P*/
       }

     //     10000     30600, 
     if ((millivolt >= 10000) && (millivolt <= 30600)) 
       {
         temp_raschyot = millivolt / 100;
       chislo[0] = temp_raschyot % 10;     //,    
         temp_raschyot = millivolt / 1000;
       chislo[1] = temp_raschyot % 10;     //,     
       chislo[2] =  millivolt / 10000;     //,     
       chislo[3] = 10;                     // /*u*/
       tochka_volt = 1;                    //      1 
       }
        
     if ((millivolt >= 1000) && (millivolt < 10000))  //     1000   10000,     
       {
         temp_raschyot = millivolt / 10;
       chislo[0] = temp_raschyot % 10;     //,    
         temp_raschyot = millivolt / 100;
       chislo[1] = temp_raschyot % 10;     //,    
       chislo[2] =  millivolt / 1000;      //,    
       chislo[3] = 10;                     // /*u*/
       tochka_volt = 2;                    //      2 
       }  
        
     if ((millivolt >= 100) && (millivolt < 1000))  //     100   1000,   
       {
         temp_raschyot = millivolt / 10;
       chislo[0] = temp_raschyot % 10;     //,    
       chislo[1] =  millivolt / 100;       //,    
       chislo[2] = 0;                      // 0
       chislo[3] = 10;                     // /*u*/
       tochka_volt = 2;                    //      2 
       }  

     if (millivolt < 100)  //   100, 
       {
       chislo[0] = millivolt / 10;    //,           
       chislo[1] = 0;                 // 0
       chislo[2] = 0;                 // 0
       chislo[3] = 10;                // /*u*/
       tochka_volt = 2;               //      2 
       }
      
     tochka_amper = 10;  //    

     if (milliamper > 3100)  //   3100, 
       {
       chislo[7] = 13;   // /*I*/
       chislo[6] = 15;   // /* */
       chislo[5] = 10;   // /*u*/ 
       chislo[4] = 14;   // /*P*/
       }
        
     //     1000     3100,    
     if ((milliamper >= 1000) && (milliamper <= 3100))  
       {
         temp_raschyot = milliamper / 10;
       chislo[4] = temp_raschyot % 10;      //,    
         temp_raschyot = milliamper / 100;
       chislo[5] = temp_raschyot % 10;      //,    
       chislo[6] =  milliamper / 1000;      //,    
       chislo[7] = 11;                      // /*i*/
       tochka_amper = 6;                    //      6 
       }  

     if ((milliamper >= 100) && (milliamper < 1000))  //     100   1000,   
       {
         temp_raschyot = milliamper / 10;
       chislo[4] = temp_raschyot % 10;      //,     
       chislo[5] =  milliamper / 100;       //,    
       chislo[6] = 0;                       // 0
       chislo[7] = 11;                      // /*i*/
       tochka_amper = 6;                    //      6 
       }  

     if (milliamper < 100)  //   100, 
       {
       chislo[4] = milliamper / 10;  //,           
       chislo[5] = 0;                // 0
       chislo[6] = 0;                // 0
       chislo[7] = 11;               // /*i*/
       tochka_amper = 6;             //      6 
       }
       
     flag_indikaciya = 0;  //        
     }
     
   delay_ms(500);  //             
   }
 }
